library(stable)
library(growth)
library(gnlm)
library(repeated)

y <- scan("abbey.dat",skip=2)
ret <- (y[2:49]-y[1:48])/y[1:48]

tim <- seq(0,0.47,by=0.01)

idx <- 1:48
x <- idx-1

sum(ret>2*sd(ret))

if(interactive()){
postscript("abbey.eps",height=5,width=5)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(x,ret,type="l",xlab="Day",ylab="Return",ylim=c(-0.045,0.045))
abline(h=2*sd(ret),lty=3)
abline(h=-2*sd(ret),lty=3)
dev.off()
postscript("abbeycor.eps",height=5)
par(mfrow=1:2,mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
corgram(ret,main="")
corgram(ret^2,main="",ylab="")
dev.off()
}

x <- seq(1,length(ret))-1
retlag1 <- c(0,ret[1:47])

print(z2 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~1,
	skew=~1, tail=~1, iloc=0.15554, idisp=-4.8, iskew=-2.24593,
	itail=1.18))
exp(z2$coef[2])
2/(1+exp(-z2$coef[3]))-1
2/(1+exp(-z2$coef[4]))

print(z3 <- stablereg(ret, delta=1/y[1:48], loc=~tim, disp=~1,
	skew=~1, tail=~1, iloc=c(0.005,-0.01), idisp=-4.8,
	iskew=-2.0, itail=0.65))

print(z5 <- stablereg(ret, delta=1/y[1:48], loc=~tim+retlag1, disp=~1,
	skew=~1, tail=~1, iloc=c(0.008,-0.018,-0.058), idisp=-4.8,
	iskew=-2, itail=0.65))

print(z8 <- stablereg(ret, delta=1/y[1:48], loc=~tim, disp=~1, skew=~1,
	tail=tail.g(1.999999), iloc=c(0,0), idisp=-4.8, iskew=-1.96859,
	oskew=F, otail=F))
print(zn1 <- glm(ret~tim))
zn1$aic/2+sum(log(y[1:48]))
print(z8a <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~1, skew=~1,
	tail=tail.g(1.999999), iloc=0, idisp=-4.2, iskew=-1.96859, 
	oskew=F, otail=F))
print(zn0 <- glm(ret~1))
zn0$aic/2+sum(log(y[1:48]))

if(interactive()){
postscript("abbey2.eps",width=5,height=5)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(x,ret,xlab="Day",ylab="Return",ylim=c(-0.045,0.045),pch=20)
lines(x,z3$loc,lty=2)
lines(x,z8$loc,lty=1)
legend(30,-0.02,legend=c("Normal","Stable"),lty=1:2,bty="n")
dev.off()
}

print(z9 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~tim, skew=~1,
	tail=~1, iloc=0.001, idisp=c(-4.66,-0.7), iskew=-6, itail=1.55))

print(z10 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~1, skew=~tim,
	tail=~1, iloc=0.0005906, idisp=-4.946, iskew=c(2.80965,-21.58217),
	itail=0.78))
2/(1+exp(-z10$coef[5]))

print(z11 <- stablereg(ret, delta=1/y[1:48], loc=~1, disp=~1, skew=~1,
	tail=~tim, iloc=0.0019, idisp=-4.77, iskew=-2,
	itail=c(2.36,-4)))

mode <- stable.mode(loc=z10$loc,disp=z10$disp,skew=z10$skew,
	tail=z10$tail)$ytilde

y.r10 <- rep(0,length(ret))
y.r90 <- rep(0,length(ret))
f10 <- function(y)dstable(y=y,loc=z10$loc[i],disp=z10$disp[i],
	skew=z10$skew[i],tail=z10$tail[i])/
	dstable(y=mode[i],loc=z10$loc[i],disp=z10$disp[i],
	skew=z10$skew[i],tail=z10$tail[i])-0.1
for(i in 1:length(ret)){
	y.r10[i] <- uniroot(f10,c(-0.5,0))$root
	y.r90[i] <- uniroot(f10,c(0,0.5))$root
	cat(c(i,y.r10[i],y.r90[i]),"\n")}

if(interactive()){
postscript(file="abbeyreg.eps",width=5,height=5)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(x,ret,xlab="Day",ylab="Return",ylim=c(-0.045,0.045),pch=20)
lines(x,mode)
lines(x,y.r10,lty=3)
lines(x,y.r90,lty=3)
dev.off()
}

gnlr(ret,delta=1/y[1:48],pmu=0.0003,psh=log(0.0002))
gar(ret,delta=1/y[1:48],preg=0.0003,psh=0.0002,pdep=0.03)
gar(ret,delta=1/y[1:48],preg=0.0003,psh=0.0002,pdep=0.03,parch=0.01)
gnlr3(ret,dist="skew Laplace",delta=1/y[1:48],pmu=0.0003,psh=log(0.0002),
	pfam=0.1)
gnlr3(ret,dist="skew Laplace",delta=1/y[1:48],pmu=-0.0034,psh=-4.71,
	family=~tim,pfam=c(-0.24,0.21))
gnlr3(ret,dist="skew Laplace",delta=1/y[1:48],mu=~tim,pmu=c(0.0000001,-0.025),
	psh=-4.87,family=~tim,pfam=c(-0.041,-1.54))
gnlr3(ret,dist="skew Laplace",delta=1/y[1:48],pmu=0.001,
	shape=~tim,psh=c(-4.43,-2.43),family=~tim,pfam=c(0.096,-2.76))
print(zsl <- gnlr3(ret,dist="skew Laplace",delta=1/y[1:48],mu=~tim,
	pmu=c(0.00093,-0.04),shape=~tim,psh=c(-4.43,-2.43),family=~tim,
	pfam=c(0.096,-2.76)))

gar(ret,dist="skew Laplace",delta=1/y[1:48],preg=0.00021,psh=c(0.01,1.1),
	pdep=0.02)
gar(ret,dist="skew Laplace",delta=1/y[1:48],preg=0.002,psh=c(0.001,0.95),
	pdep=0.0001,parch=0.71)
gar(ret,dist="skew Laplace",delta=1/y[1:48],preg=0.002,psh=c(0.001,0.9),
	parch=0.71)

p <- zsl$coef
slmode <- function(tim) {
	height <- mode <- rep(0,length(ret))
	for(i in 1:length(ret)){
		fn <- function(pp)-dskewlaplace(pp,p[1]+p[2]*tim[i],
			exp(p[3]+p[4]*tim[i]),exp(p[5]+p[6]*tim[i]))
		tmp <- nlm(fn,p=0)
		mode[i] <- tmp$est
		height[i] <- tmp$min}
	list(mode,-height)}
print(mode <- slmode(tim))

y.r10 <- rep(0,length(ret))
y.r90 <- rep(0,length(ret))
f10 <- function(y)dskewlaplace(y=y,p[1]+p[2]*tim[i],
	exp(p[3]+p[4]*tim[i]),exp(p[5]+p[6]*tim[i]))/
	dskewlaplace(y=mode[[1]][i],p[1]+p[2]*tim[i],
	exp(p[3]+p[4]*tim[i]),exp(p[5]+p[6]*tim[i]))-0.1
for(i in 1:length(ret)){
	y.r10[i] <- uniroot(f10,c(-0.5,0))$root
	y.r90[i] <- uniroot(f10,c(0,0.5))$root
	cat(c(i,y.r10[i],y.r90[i]),"\n")}

if(interactive()){
plot(seq(-0.04,0.04,by=0.001),dskewlaplace(seq(-0.04,0.04,by=0.001),
	p[1]+p[2]*tim[48],exp(p[3]+p[4]*tim[48]),exp(p[5]+p[6]*tim[48])),
	type="l")
plot(seq(-0.04,0.04,by=0.001),dskewlaplace(seq(-0.04,0.04,by=0.001),
	p[1]+p[2]*tim[1],exp(p[3]+p[4]*tim[1]),exp(p[5]+p[6]*tim[1])),type="l")
postscript(file="abbeyreg2.eps",width=5,height=5)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(x,ret,xlab="Day",ylab="Return",ylim=c(-0.045,0.045),pch=20)
lines(x,mode[[1]])
lines(x,y.r10,lty=3)
lines(x,y.r90,lty=3)
dev.off()
}
