library(gnlm)
library(repeated)

reps <- rmna(restovec(read.list("sheep.dat",skip=4,order=2:1),name="y"))
reps <- transform(reps,ly=log(y))

mu2 <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],p[2],-p[1]-p[3]),ncol=2)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[2,])}
	ret}
mu3 <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],0,p[2],-p[1]-p[2],p[1],0,p[2],-p[1]-p[3]),
		ncol=3)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[3,])}
	ret}
mu4 <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],0,0,p[2],-p[1]-p[2],p[1],0,
		0,p[2],-p[1]-p[2],p[1],0,0,p[2],-p[1]-p[3]),ncol=4)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[4,])}
	ret}
mu5 <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],0,0,0,p[2],-p[1]-p[2],p[1],0,0,
		0,p[2],-p[1]-p[2],p[1],0,0,0,p[2],-p[1]-p[2],p[1],
		0,0,0,p[2],-p[1]-p[3]),ncol=5)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[5,])}
	ret}
mu3a <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],0,p[2],-p[1]-p[3],0,0,p[3],-p[3]),ncol=3)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[2,])}
	ret}
mu4a <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],0,0,p[2],-p[1]-p[2],p[1],0,0,p[2],-p[1]-p[3],
		0,0,0,p[3],-p[3]),ncol=4)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[3,])}
	ret}

lmu2 <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],p[2],-p[1]-p[3]),ncol=2)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[2,])}
	log(ret)}
lmu3 <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],0,p[2],-p[1]-p[2],p[1],0,p[2],-p[1]-p[3]),
		ncol=3)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[3,])}
	log(ret)}
lmu4 <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],0,0,p[2],-p[1]-p[2],p[1],0,
		0,p[2],-p[1]-p[2],p[1],0,0,p[2],-p[1]-p[3]),ncol=4)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[4,])}
	log(ret)}
lmu5 <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],0,0,0,p[2],-p[1]-p[2],p[1],0,0,
		0,p[2],-p[1]-p[2],p[1],0,0,0,p[2],-p[1]-p[2],p[1],
		0,0,0,p[2],-p[1]-p[3]),ncol=5)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[5,])}
	log(ret)}
lmu3a <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],0,p[2],-p[1]-p[3],0,0,p[3],-p[3]),ncol=3)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[2,])}
	log(ret)}
lmu4a <- function(p){
	p <- exp(p)
	V <- matrix(c(-p[2],p[1],0,0,p[2],-p[1]-p[2],p[1],0,0,p[2],-p[1]-p[3],
		0,0,0,p[3],-p[3]),ncol=4)
	ret <- rep(0,length(times))
	for(i in 1:length(times)){
		prop <- if(i<=8)p[4] else if(i<=16)p[5]
			else if(i<=24)p[6] else p[7]
		ret[i] <- prop*sum(mexp(V,times[i])[3,])}
	log(ret)}

print(zn3a <- gnlr(y,mu=mu3a,pmu=c(-1.3,-2,-0.4,4.7,5,5.5,5.8),dist="normal",
	psh=3.6,env=reps))
print(zn4a <- gnlr(y,mu=mu4a,pmu=c(-1,-1.1,-0.35,4.7,5,5.5,5.8),
	dist="normal",psh=3.6,env=reps))

print(zg1 <- gnlr(y,mu=function(p,linear)exp(linear),linear=~individuals+times,
	pmu=c(1.6,4.7,5.1,5.2,5.6),dist="gamma",psh=3,env=reps))
print(zg2 <- gnlr(y,mu=mu2,pmu=c(-4.3,-4.3,-1.6,4.7,5.1,5.2,5.6),dist="gamma",
	psh=3,env=reps))
print(zg3 <- gnlr(y,mu=mu3,pmu=c(-4.15,-3.8,-1.5,4.8,5.1,5.2,5.7),
	dist="gamma",psh=2.9,env=reps))
print(zg4 <- gnlr(y,mu=mu4,pmu=c(-4.15,-3.8,-1.5,4.8,5.1,5.2,5.7),
	dist="gamma",psh=3,env=reps))
print(zg5 <- gnlr(y,mu=mu5,pmu=c(-4.15,-3.8,-1.5,4.8,5.1,5.2,5.7),
	dist="gamma",psh=3,env=reps))
print(zg3a <- gnlr(y,mu=mu3a,pmu=c(-3.4,-4.1,-1.1,4.4,4.8,4.9,5.3),
	dist="gamma",psh=2.9,env=reps))
print(zg4a <- gnlr(y,mu=mu4a,pmu=c(-3.6,-4,-1.1,4.4,4.8,4.9,5.3),
	dist="gamma",psh=2.6,env=reps))

print(zln1 <- gnlr(ly,mu=~individuals+times,
	pmu=c(4.7,5.1,5.2,5.6,0),dist="normal",psh=0,env=reps))
print(zln2 <- gnlr(ly,mu=lmu2,pmu=c(-4.2,-4.2,-1.5,4.8,5.1,5.2,5.7),
	dist="normal",psh=-3,env=reps))
sum((zln2$fit-response(reps,name="ly"))^2)
print(zln3 <- gnlr(ly,mu=lmu3,pmu=c(-4.3,-4.1,-1.5,4.7,5.1,5.2,5.7),
	dist="normal",psh=-3,env=reps))
sum((zln3$fit-response(reps,name="ly"))^2)
print(zln4 <- gnlr(ly,mu=lmu4,pmu=c(-4.3,-4.1,-1.5,4.7,5.1,5.2,5.7),
	dist="normal",psh=-3,env=reps))
sum((zln4$fit-response(reps,name="ly"))^2)
print(zln5 <- gnlr(ly,mu=lmu5,pmu=c(-4.3,-4.1,-1.5,4.7,5.1,5.2,5.7),
	dist="normal",psh=-3,env=reps))
sum((zln5$fit-response(reps,name="ly"))^2)
print(zln3a <- gnlr(ly,mu=lmu3a,pmu=c(-3.4,-4,-1,4.5,4.8,5,5.5),
	dist="normal",psh=-2.9,env=reps))
print(zln4a <- gnlr(ly,mu=lmu4a,pmu=c(-3.6,-3.8,-1,4.5,4.8,5,5.5),
	dist="normal",psh=-2.9,env=reps))

print(zgar4 <- gar(y,mu=mu4,preg=c(-4.15,-3.8,-1.5,4.8,5.1,5.2,5.7),
	dist="gamma",psh=3,pdep=0.3,env=reps))

if(interactive()){
postscript("sheep.eps",width=5,height=5)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
# same curve as independence model, and easier to plot
plot(mprofile(zgar4),nind=1:4,xlab="Days",
	ylab="Renal gentamicin concentration")
plot(iprofile(zgar4),nind=1:4,pch=c(1:2,5:6),lty=rep(0,4),add=T)
legend(40,120,legend=c("Sheep 1","Sheep 2","Sheep 3","Sheep 4"),
	lty=1:4,pch=c(1:2,5:6),bty="n")
dev.off()
}
