library(gnlm)

data <- read.table("mortality.dat",skip=3,header=T)
attach(data)
Population <- Population*100

rate <- function(p){
	A <- 1/(1+exp(-p[1]))
	B <- 1/(1+exp(-p[2]))
	C <- 1/(1+exp(-p[3]))
	D <- 1/(1+exp(-p[4]))
	E <- p[5]
	F <- 15+95/(1+exp(-p[6]))
	G <- 1/(1+exp(-p[7]))
	H <- log(p[8])
	tmp <- A^((Age+B)^C)+D*exp(-E*(log(Age/F))^2)+G*H^Age
	tmp/(1+tmp)}
#print(zb <- gnlr(cbind(Deaths,Population-Deaths),dist="binomial",mu=rate,
#	pmu=c(-7.6,-4,-2.2,-8.7,10.72,-3.2,-11,3)))
print(zb <- gnlr(cbind(Deaths,Population-Deaths),dist="binomial",mu=rate,
	pmu=c(-7.51,-4.04,-2.18,-8.75,10.73,-3.22,-10.90,3.03)))
print(zbb <- gnlr(cbind(Deaths,Population-Deaths),dist="beta binomial",mu=rate,
	pmu=c(-7.51,-4.04,-2.18,-8.75,10.73,-3.22,-10.90,3.03),psh=13.4))
print(zbs <- glm(cbind(Deaths,Population-Deaths)~as.factor(Age),
	family=binomial))
zbs$aic/2

if(interactive()){
postscript(file="mortality.eps",height=5,width=5)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(Age,log(Deaths/Population),type="l",xlab="Age",ylab="Log death rate")
lines(Age,log(zb$fitted/Population),lty=2)
#lines(Age,log(zbb$fitted/Population),lty=3)
legend(10,-4,legend=c("Observed","Fitted"),lty=1:2,bty="n")
dev.off()
}
