library(event)

data <- read.table("myeloid.dat",skip=5,head=T)
attach(data)
id <- tv <- tv2 <- times <- censor <- state <- ada <- NULL
for(i in 1:55){
	ll <- sum(Id==i)
	times <- c(times,Times[Id==i][ll])
	tv2 <- c(tv2,diff(Times[Id==i]))
	tv <- c(tv,c(0,diff(Times[Id==i])))
	censor <- c(censor,State[Id==i][ll]==3)
	st <- 1
	ada <- c(ada,c(ADA[Id==i][1],ADA[Id==i][1:(ll-1)]))
	for(j in 2:ll){
		state <- c(state,st)
		if(State[Id==i][j-1]!=State[Id==i][j]){
			st <- st+1}}
	id <- c(id,rep(i,ll-1))}

y <- pp(times,cens=censor)
pst <- tvcov(tv2,state,tv2)-1
pada <- tvcov(tv2,ada,tv)
tp <- tpast(times)

if(interactive()){
postscript("myeloidsurv.eps",height=5,width=5)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(km(times=times,censor=censor),main="",xlab="Days",
	ylab="Survival probability",xlim=c(0,1050))
dev.off()
}

# exponential
ehr(y,plambda=-5)
ehr(y,plambda=c(-6.2,1),lambda=~pst)
ehr(y,plambda=c(-6.2,0),lambda=~pada)
ehr(y,plambda=c(-6.7,1.14,0.03),lambda=~pst+pada)
ehr(y,plambda=c(-6.7,1.14,0.02,0),lambda=~pst*pada)

# Weibull
ehr(y,plambda=c(-5,0),lambda=~log(tp))
ehr(y,plambda=c(-5.8,-0.14,1),lambda=~log(tp)+pst)
ehr(y,plambda=c(-5.8,-0.14,0),lambda=~log(tp)+pada)
ehr(y,plambda=c(-6.65,-0.03,1,0.03),lambda=~log(tp)+pst+pada)
ehr(y,plambda=c(-6.65,-0.03,1,0.03,0.001),lambda=~log(tp)+pst*pada)
ehr(y,plambda=c(-5.14,-0.36,0.033,-0.001),lambda=~log(tp)*pada)
ehr(y,plambda=c(-5.81,-0.23,0.16,0.025,0.34,0.0015),lambda=~log(tp)*(pst+pada))
ehr(y,plambda=c(-5.7,-0.3,0.16,0.085,0.34),lambda=~log(tp)*pst+pada)

# gamma
lambda <- function(p) {
       p <- exp(p)
       dgamma(tp,p[1],scale=p[2],log=T)-pgamma(tp,p[1],scale=p[2],lower=F,log=T)}
ehr(y,plambda=c(log(0.8),log(890)),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1])
	p2 <- exp(p[2]+p[3]*pst)
	dgamma(tp,p1,scale=p2,log=T)-pgamma(tp,p1,scale=p2,lower=F,log=T)}
ehr(y,plambda=c(-0.24,6.8,0),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1])
	p2 <- exp(p[2]+p[3]*pada)
	dgamma(tp,p1,scale=p2,log=T)-pgamma(tp,p1,scale=p2,lower=F,log=T)}
ehr(y,plambda=c(-0.24,6.8,0),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1])
	p2 <- exp(p[2]+p[3]*pst+p[4]*pada)
	dgamma(tp,p1,scale=p2,log=T)-pgamma(tp,p1,scale=p2,lower=F,log=T)}
ehr(y,plambda=c(-0.1,6.85,-1,-0.03),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1])
	p2 <- exp(p[2]+p[3]*pst+p[4]*pada+p[5]*pst*pada)
	dgamma(tp,p1,scale=p2,log=T)-pgamma(tp,p1,scale=p2,lower=F,log=T)}
ehr(y,plambda=c(-0.1,6.85,-1,-0.03,0),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1]+p[2]*pada)
	p2 <- exp(p[3]+p[4]*pada)
	dgamma(tp,p1,scale=p2,log=T)-pgamma(tp,p1,scale=p2,lower=F,log=T)}
ehr(y,plambda=c(0.9,0,6,-0.03),lambda=lambda)
lambda <- function(p) {
	p1 <- exp(p[1]+p[2]*pada+p[3]*pst)
	p2 <- exp(p[4]+p[5]*pada+p[6]*pst)
	dgamma(tp,p1,scale=p2,log=T)-pgamma(tp,p1,scale=p2,lower=F,log=T)}
ehr(y,plambda=c(1,-0.087,1.25,5.8,0.04,-2.84),lambda=lambda)

# log normal
lambda <- function(p) log(dlnorm(tp,p[1],p[2]))-log(1-plnorm(tp,p[1],p[2]))
ehr(y,plambda=c(7,2),lambda=lambda)
lambda <- function(p)
	dlnorm(tp,p[1]+p[2]*pst,p[3],T)-plnorm(tp,p[1]+p[2]*pst,p[3],F,T)
ehr(y,plambda=c(6.7,-0.044,1.8),lambda=lambda)
lambda <- function(p)
	dlnorm(tp,p[1]+p[2]*pada,p[3],T)-plnorm(tp,p[1]+p[2]*pada,p[3],F,T)
ehr(y,plambda=c(6.7,-0.044,1.8),lambda=lambda)
lambda <- function(p) dlnorm(tp,p[1]+p[2]*pada+p[3]*pst,p[4],T)-
	plnorm(tp,p[1]+p[2]*pada+p[3]*pst,p[4],F,T)
ehr(y,plambda=c(6.5,-0.044,-1,2.1),lambda=lambda)
lambda <- function(p) dlnorm(tp,p[1]+p[2]*pada+p[3]*pst+p[4]*pada*pst,
	p[5],T)-plnorm(tp,p[1]+p[2]*pada+p[3]*pst+p[4]*pada*pst,p[5],F,T)
ehr(y,plambda=c(6.74,-0.044,-0.96,0,1.76),lambda=lambda)
lambda <- function(p) dlnorm(tp,p[1]+p[2]*pada,exp((p[3]+p[4]*pada)/2),T)-
	plnorm(tp,p[1]+p[2]*pada,exp((p[3]+p[4]*pada)/2),F,T)
ehr(y,plambda=c(6.7,-0.046,1,0),lambda=lambda)
lambda <- function(p)
	dlnorm(tp,p[1]+p[2]*pada+p[3]*pst,exp((p[4]+p[5]*pada+p[6]*pst)/2),T)-
	plnorm(tp,p[1]+p[2]*pada+p[3]*pst,exp((p[4]+p[5]*pada+p[6]*pst)/2),F,T)
print(zln <- ehr(y,plambda=c(7.28,-0.068,-1.89,0.79,0.0046,-1.36),
	lambda=lambda))
> zln$coef[5]/2
[1] 0.005375648

# log logistic
lambda <- function(p) dlogis(log(tp),p[1],p[2],T)-log(tp)-
	plogis(log(tp),p[1],p[2],F,T)
ehr(y,plambda=c(7,2),lambda=lambda)
lambda <- function(p) dlogis(log(tp),p[1]+p[2]*pst,p[3],T)-log(tp)-
	plogis(log(tp),p[1]+p[2]*pst,p[3],F,T)
ehr(y,plambda=c(6.26,0,1.1),lambda=lambda)
lambda <- function(p) dlogis(log(tp),p[1]+p[2]*pada,p[3],T)-log(tp)-
	plogis(log(tp),p[1]+p[2]*pada,p[3],F,T)
ehr(y,plambda=c(6.26,0,1.1),lambda=lambda)
lambda <- function(p) dlogis(log(tp),p[1]+p[2]*pst+p[3]*pada,p[4],T)-log(tp)-
	plogis(log(tp),p[1]+p[2]*pst+p[3]*pada,p[4],F,T)
ehr(y,plambda=c(6.26,-1.1,-0.05,1.1),lambda=lambda)
lambda <- function(p) dlogis(log(tp),p[1]+p[2]*pst+p[3]*pada+p[4]*pst*pada,
	p[5],T)-log(tp)-plogis(log(tp),p[1]+p[2]*pst+p[3]*pada+p[4]*pst*pada,
	p[5],F,T)
ehr(y,plambda=c(8.8,-1,-0.2,-2.2,1.04),lambda=lambda,stepmax=1)
lambda <- function(p) dlogis(log(tp),p[1]+p[2]*pada,exp(p[3]+p[4]*pada)*
	sqrt(3)/pi,T)-log(tp)-
	plogis(log(tp),p[1]+p[2]*pada,exp(p[3]+p[4]*pada)*sqrt(3)/pi,F,T)
ehr(y,plambda=c(7.15,-0.097,0.44,0.04),lambda=lambda)
lambda <- function(p) dlogis(log(tp),p[1]+p[2]*pada+p[3]*pst,exp(p[4]+
	p[5]*pada+p[6]*pst)*sqrt(3)/pi,T)-log(tp)-
	plogis(log(tp),p[1]+p[2]*pada+p[3]*pst,exp(p[4]+p[5]*pada+p[6]*pst)*
	sqrt(3)/pi,F,T)
print(zll <- ehr(y,plambda=c(7.315,-0.1,-1.4,0.45,0.04,-0.6),lambda=lambda))

# log Cauchy
lambda <- function(p) dcauchy(log(tp),p[1],p[2],T)-log(tp)-
	pcauchy(log(tp),p[1],p[2],F,T)
ehr(y,plambda=c(6,1),lambda=lambda)
lambda <- function(p) dcauchy(log(tp),p[1]+p[2]*pst,p[3],T)-log(tp)-
	pcauchy(log(tp),p[1]+p[2]*pst,p[3],F,T)
ehr(y,plambda=c(5.9,0,0.9),lambda=lambda)
lambda <- function(p) dcauchy(log(tp),p[1]+p[2]*pada,p[3],T)-log(tp)-
	pcauchy(log(tp),p[1]+p[2]*pada,p[3],F,T)
ehr(y,plambda=c(5.9,0,0.9),lambda=lambda)
lambda <- function(p) dcauchy(log(tp),p[1]+p[2]*pst+p[3]*pada,p[4],T)-log(tp)-
	pcauchy(log(tp),p[1]+p[2]*pst+p[3]*pada,p[4],F,T)
ehr(y,plambda=c(8,-0.12,0,1),lambda=lambda)
lambda <- function(p) dcauchy(log(tp),p[1]+p[2]*pst+p[3]*pada+
	p[4]*pst*pada,p[5],T)-log(tp)-
	pcauchy(log(tp),p[1]+p[2]*pst+p[3]*pada+p[4]*pst*pada,p[5],F,T)
ehr(y,plambda=c(8.58,-1.24,-0.18,0,1),lambda=lambda)
lambda <- function(p) dcauchy(log(tp),p[1]+p[2]*pada,exp(p[3]+p[4]*pada),T)-
	log(tp)-pcauchy(log(tp),p[1]+p[2]*pada,exp(p[3]+p[4]*pada),F,T)
ehr(y,plambda=c(8,-0.12,1,0.08),lambda=lambda)
lambda <- function(p) dcauchy(log(tp),p[1]+p[2]*pada+p[3]*pst,
	exp(p[4]+p[5]*pada+p[6]*pst),T)-log(tp)-pcauchy(log(tp),
	p[1]+p[2]*pada+p[3]*pst,exp(p[4]+p[5]*pada+p[6]*pst),F,T)
ehr(y,plambda=c(4.57,-0.0017,0.29,3.92,-0.17,-5),lambda=lambda)

if(interactive()){
postscript("myeloidrisk.eps",height=5,width=5)
tt <- seq(1,1050,by=10)
padam <- mean(pada)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
p <- zll$coef
plot(tt,exp(dlogis(log(tt),p[1]+p[2]*padam+p[3],exp(p[4]+
	p[5]*padam+p[6])*sqrt(3)/pi,T)-log(tt)-
	plogis(log(tt),p[1]+p[2]*padam+p[3],exp(p[4]+p[5]*padam+p[6])*
	sqrt(3)/pi,F,T)),lty=2,
	type="l",ylab="Intensity",xlab="Days",ylim=c(0,0.005),xlim=c(0,1050))
lines(tt,exp(dlogis(log(tt),p[1]+p[2]*padam,exp(p[4]+
	p[5]*padam)*sqrt(3)/pi,T)-log(tt)-
	plogis(log(tt),p[1]+p[2]*padam,exp(p[4]+p[5]*padam)*
	sqrt(3)/pi,F,T)),lty=1)
legend(100,0.005,legend=c("Chronic phase","Blast phase"),lty=c(1,2),bty="n")
dev.off()
}
