freq <- scan("blood.dat",skip=5)
initial <- gl(3,3,labels=c("Normal","Borderline","Elevated"))
followup <- gl(3,1,9,labels=c("Normal","Borderline","Elevated"))
walk <- as.factor(c(1,2,3,
		    2,1,2,
		    3,2,1))
drift <- as.factor(c(1,2,3,
		    4,1,2,
		    5,4,1))

trans <- matrix(freq,ncol=3,byrow=T)
trans/rep(apply(trans,1,sum),3)
trans/sum(freq)
apply(trans,1,sum)/sum(freq)
apply(trans,2,sum)/sum(freq)

print(z0 <- summary(glm(freq~initial+followup,family=poisson)))
z0$aic/2
print(zw <- summary(glm(freq~initial+followup+walk,family=poisson)))
zw$aic/2
print(zwms <- summary(glm(freq~initial+followup+walk,family=poisson,
	weights=initial!=followup)))
zwms$aic/2-sum(dpois(freq,freq,T)[initial==followup])+3
print(zd <- summary(glm(freq~initial+followup+drift,family=poisson)))
zd$aic/2
print(zf <- summary(glm(freq~initial*followup,family=poisson)))
zf$aic/2
