library(gnlm)
library(repeated)

freq <- scan("glass5.dat",skip=7)
son <- gl(5,1,25,labels=c("Prof","Exec","Super","Skilled","Unskilled"))
father <- gl(5,5,25,labels=c("Prof","Exec","Super","Skilled","Unskilled"))
sym <- as.factor(c(11,1,2,3,4,
		   1,12,5,6,7,
		   2,5,13,8,9,
		   3,6,8,14,10,
		   4,7,9,10,15))

trans <- matrix(freq,ncol=5,byrow=T)
trans/rep(apply(trans,1,sum),5)
apply(trans,1,sum)/sum(freq)
apply(trans,2,sum)/sum(freq)

print(z0 <- summary(glm(freq~father+son,family=poisson)))
z0$aic/2
print(zs <- summary(glm(freq~sym,family=poisson)))
zs$aic/2
print(zqs <- summary(glm(freq~sym+father+son,family=poisson)))
zqs$aic/2
print(zf <- summary(glm(freq~father*son,family=poisson)))
zf$aic/2

print(z1 <- marg.hom(freq,father,son))

m <- matrix(0,ncol=25,nrow=5)
for(i in 1:5)for(j in 1:5)m[i,5*(j-1)+i] <- m[i,5*(i-1)+j] <- 1
for(i in 1:5)m[i,i+(i-1)*5] <- 2
mm <- diag(25)
m2 <- t(rbind(m[2:5,],mm[c(7:10,12:15,17:20,22:25),]))
print(z2 <- gnlr(freq,dist="Poisson",mu=~exp(linear),linear=~m2,
	pmu=c(1,rep(0.2,4),rep(0,16))))

print(z3 <- gnlr(freq,dist="Poisson",mu=~exp(linear),linear=~t(m[2:5,]),
	pmu=c(1,rep(0.2,4))))
