library(event)

y <- scan("dog.dat",skip=6)

trial <- as.numeric(gl(25,1,750))-1
dog <- gl(30,25,750)
x <- rep(0,750)
for(j in 1:30){
  i <- (dog==j)
  x <- x+(cumsum(y*i)-y)*i}
jx <- trial-x
pw <- (trial>0)
y <- 1-y
x[trial==0] <- 1

if(interactive()){
postscript("dog.eps",height=5,width=5)
par(mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
cprocess(events=matrix(1-y,ncol=25,byrow=T),lty=rep(1,30),
	xlab="Trial",ylab="Total avoidances")
dev.off()
}

print(z0 <- glm(y~x+jx-1,family=binomial(link="log"),weights=pw))
z0$aic/2
exp(z0$coef)
print(z1 <- glm(y~x+jx-1,family=binomial,weights=pw))
z1$aic/2
print(z2 <- glm(y~x+jx,family=binomial,weights=pw))
z2$aic/2
