library(gnlm)
library(event)

tt <- read.list("mines.dat",skip=8,nline=1)
cens <- rep(0,7)
id <- wt <- cn <- birth <- birtht <- te <- NULL
for(i in 1:7){
	tmp <- NULL
	for(j in 1:length(tt[[i]])){
		if(tt[[i]][j]>0) tmp <- c(tmp,1)
		else tmp[length(tmp)] <- tmp[length(tmp)]+1}
	wt <- c(wt,tmp)
	birtht <- c(birtht,c(0,cumsum(tmp)[1:(length(tmp)-1)]))
	birth <- c(birth,1:length(tt[[i]][tt[[i]]>0]))
	id <- c(id,rep(i,length(tt[[i]][tt[[i]]>0])))
	te <- c(te,cumsum(tt[[i]]))
	cn <- c(cn,c(0,rep(1,length(tt[[i]])-2),0))}
id <- as.factor(id)

if(interactive()){
times <- events <- list()
for(i in 1:7){
	tmp <- NULL
	for(j in 1: length(tt[[i]])){
		if(tt[[i]][j]>0) tmp <- c(tmp,1)
		else tmp[length(tmp)] <- tmp[length(tmp)]+1}
	events <- c(events,list(tmp))
	times <- c(times,list(tt[[i]][tt[[i]]>0]))}
postscript("mines.eps",height=5)
par(mfrow=c(1,2),font.main=1,mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
cprocess(times,number=T,ylim=c(0,65),xlab="Days",main="Days with accidents")
cprocess(times,events,number=T,ylim=c(0,65),ylab="",xlab="Days",
	main="Total accidents")
dev.off()
}

tt <- restovec(tt,cens=cens)
te <- te[response(tt)[,1]>0]
y <- cbind(response(tt)[response(tt)[,1]>0,1],cn[response(tt)[,1]>0])
mu <- function(p,linear) exp(linear)
mub <- function(p) exp(p[1]+p[2]*birth)
mubt <- function(p) exp(p[1]+p[2]*birtht)
mut <- function(p) exp(p[1]+p[2]*te)
shb <- function(p) p[1]+p[2]*birth
famt <- function(p) p[1]+p[2]*te

gnlr(y,"Weibull",pmu=5,pshape=0,wt=wt)
gnlr(y,"Weibull",pmu=c(5,rep(0,6)),pshape=0.2,mu=mu,linear=~id,wt=wt)
print(zw <- kalsurv(tt,pinit=1.5,preg=1,psh=1,intensity="Weibull",
	dep="frailty"))
gnlr3(y,"Burr",pmu=5,pshape=0,pfam=0,wt=wt)
gnlr3(y,"Burr",pmu=c(3,rep(0,6)),pshape=-0.4,mu=mu,linear=~id,pfam=1,wt=wt)
gnlr3(y,"Burr",pmu=3,pshape=-0.4,fam=famt,pfam=c(2,-0.01),wt=wt)

# birth
gnlr(y,"Weibull",pmu=c(3,-0.1),pshape=-0.4,mu=mu,linear=~birth,wt=wt)
gnlr(y,"Weibull",pmu=c(8,-0.1,rep(0,6)),pshape=0.2,mu=mu,
	linear=~birth+id,wt=wt)
print(zwb <- kalsurv(tt,pinit=1.5,preg=1,psh=1,pbirth=0,intensity="Weibull",
	dep="frailty"))
gnlr3(y,"Burr",pmu=c(3,-0.1),pshape=-0.4,mu=mu,linear=~birth,pfam=1,wt=wt)
gnlr3(y,"Burr",pmu=c(3,-0.1,rep(0,6)),pshape=-0.4,mu=mu,linear=~birth+id,
	pfam=1,wt=wt)
gnlr3(y,"Burr",pmu=c(3,-0.1),pshape=-0.4,mu=mu,linear=~birth,fam=famt,
	pfam=c(2,-0.01),wt=wt)

gnlr3(y,"Burr",pmu=c(3,-0.1,rep(0,6)),pshape=-0.4,mu=mu,linear=~birth+id,
	fam=famt,pfam=c(2,-0.01),wt=wt)

gnlr3(y,"Burr",pmu=c(5.7,-0.1),pshape=c(0.4,-0.001),mu=mu,linear=~birth,
	fam=famt,pfam=c(5.4,-0.02),sh=famt,wt=wt)
gnlr3(y,"Burr",pmu=c(5.7,-0.1),pshape=c(0.4,-0.001),mu=mu,linear=~birth,
	fam=famt,pfam=c(5.4,-0.02),sh=shb,wt=wt)
