library(event)
library(repeated)

y <- scan("mines2.dat",skip=2)

length(y)/sum(y)
length(y)/sum(y)*365.25

sy <- cumsum(y)
int <- seq(0,41000,by=365.25)
times <- seq(182.625,40549,by=365.25)

if(interactive()){
postscript(file="mineshist.eps",height=5)
par(mfrow=c(1,2),mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
cprocess(y,xlab="Days",ylab="Number of accidents")
freq <- hist(sy,breaks=int,xlab="Days",ylab="Accidents/yr",
	main="")$counts
box()
dev.off()
}else{
freq <- rep(0,112)
for(i in 1:112)freq[i] <- sum(sy>=int[i]&sy<int[i+1])
}

u1 <- 1:190

likee <- function(p) -sum(dexp(y,mu(p),T))
mu <- function(p) exp(p[1]+p[2]*(u1>i))
zce <- este <- lle <- NULL
zce$est  <- c(0.5,-0.5)
for(i in u1){
	zce <- nlm(likee,zce$est)
	lle <- c(lle,-zce$min)
	este <- rbind(este,zce$est)}
-max(lle)
tmp <- este[lle==max(lle),]
c(exp(tmp[1]),exp(tmp[1]+tmp[2]))
1/c(mean(y[1:124]),mean(y[125:190]))
c(exp(tmp[1]),exp(tmp[1]+tmp[2]))*365.25
sum(y[1:124])
sum(y[1:124])/365.25

print(ze <- cphidden(y,dist="exponential",mu=~rep(exp(a),190),pmu=c(-5,-6),
	pgamma=0.01))
exp(ze$coef)
exp(ze$coef)*365.25
sum(y[1:133])
sum(y[1:133])/365.25
mexp(ze$gamma)

print(zp <- cphidden(freq,dist="Poisson",mu=~rep(exp(a),112),pmu=c(1,-1),
	pgamma=0.03))
exp(zp$coef)
exp(zp$coef)/365.25
mexp(zp$gamma)

if(interactive()){
postscript(file="mineschange.eps",height=5)
par(mfrow=c(1,2),mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(u1[110:135],exp(lle-max(lle))[110:135],type="l",xlab="Intervals",
	ylab="Normed likelihood")
plot(u2[30:50],exp(llp-max(llp))[30:50],type="l",xlab="Years",ylab="")
dev.off()
postscript(file="mineshmm.eps",height=5)
par(mfrow=c(1,2),mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(ze,xlab="Intervals",ylab="Probability of state 1",main="")
plot(zp,xlab="Years",ylab="",main="")
dev.off()
}
