library(event)

data <- as.matrix(read.table("nematode.dat",skip=2))

nemasys <- data[1:5,]
print(zb1 <- pbirth(nemasys,p=-1,int="binomial"))
print(zbb1 <- pbirth(nemasys,p=c(1,3),int="binomial exponential"))
print(zblb1 <- pbirth(nemasys,p=c(1,1,-1),int="binomial logistic"))
print(zbtb1 <- pbirth(nemasys,p=c(1,2.1,-0.3,0),int="binomial total"))

sus94 <- data[6:10,]
print(zb2 <- pbirth(sus94,p=-1,int="binomial"))
print(zbb2 <- pbirth(sus94,p=c(-1.3,0.3),int="binomial exponential"))
print(zblb2 <- pbirth(sus94,p=c(1,1,-1),int="binomial logistic"))
print(zbtb2 <- pbirth(sus94,p=c(-0.3,0.6,-0.6,0),int="binomial total"))

sus11 <- data[11:15,]
print(zb3 <- pbirth(sus11,p=-1,int="binomial"))
print(zbb3 <- pbirth(sus11,p=c(2,2),int="binomial exponential"))
print(zblb3 <- pbirth(sus11,p=c(1,2,-1),int="binomial logistic"))
print(zbtb3 <- pbirth(sus11,p=c(0.1,2,-0.8,0),int="binomial total"))

zb1$aic+zb2$aic+zb3$aic
zbb1$aic+zbb2$aic+zbb3$aic
zblb1$aic+zblb2$aic+zblb3$aic
zbtb1$aic+zbtb2$aic+zbtb3$aic
zbb1$aic+zblb2$aic+zbtb3$aic

if(interactive()){
postscript("nematode.eps",height=5)
par(mfrow=c(1,2),mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(0:10,zbb1$an*(10-0:10),type="l",ylim=c(0,6),xlab=expression(n),
	ylab=expression(lambda[n]))
lines(0:10,zblb2$an*(10-0:10),lty=3)
lines(0:10,zbtb3$an*(10-0:10),lty=2)
plot(0:10,zbb1$an,type="l",ylim=c(0,2),xlab=expression(n),
	ylab=expression(lambda[n]/(10-n)))
lines(0:10,zblb2$an,lty=3)
lines(0:10,zbtb3$an,lty=2)
legend(0,1.7,legend=c("Nemasys","Sus94","Sus11"),lty=c(1,3,2),bty="n")
dev.off()
}

print(zb4 <- pbirth(data,p=-1,int="binomial"))
print(zbb4 <- pbirth(data,p=c(1,3),int="binomial exponential"))
print(zblb4 <- pbirth(data,p=c(1,2,-1),int="binomial logistic"))
print(zbtb4 <- pbirth(data,p=c(0.2,1.5,-0.55,0),int="binomial total"))
