library(event)
library(gnlm)

data <- scan("snoq.dat")
prec <- y <- NULL
j <- 0
for(i in 1:36){
      y <- rbind(y,as.numeric(data[(1+j):(31+j)]>0))
      prec <- rbind(prec,data[(1+j):(31+j)])
      j <- j+(365+((i%%4)==1))}

if(interactive()){
postscript("snoq.eps",height=5)
par(mfrow=c(1,2),font.main=1,mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
cprocess(events=y,xlab="Days",ylab="Wet days",xaxt="n")
axis(1,c(0,10,20,30))
cprocess(events=prec/100,xlab="Days",ylab="Precipitation (in)",xaxt="n")
axis(1,c(0,10,20,30))
dev.off()
}

py <- NULL
j <- 0
for(i in 2:36){
      j <- j+(365+((i%%4)==1))
      py <- c(py,data[j+1])}
py <- as.vector(t(cbind(c(1,as.numeric(py>0)),y[,1:30])))
yy <- NULL
j <- 0
for(i in 1:36){
      yy <- rbind(yy,data[(1+j):(31+j)])
      j <- j+(365+((i%%4)==1))}
yy <- as.vector(t(ifelse(yy>0,yy,0.5)))

cens <- ifelse(yy>0.5,1,-1)
lyy <- log(yy)
mu <- function(p) exp(p[1])
gnlr(cbind(yy,cens),dist="gamma",mu=mu,pmu=1,psh=0,delta=0.5)
gnlr(cbind(yy,cens),dist="Weibull",mu=mu,pmu=1,psh=0,delta=0.5)
gnlr(cbind(yy,cens),dist="inverse Gauss",mu=mu,pmu=4,psh=-2,delta=0.5)
gnlr(cbind(yy,cens),dist="Pareto",mu=mu,pmu=11.1,psh=0.0001,delta=0.5)
gnlr(cbind(lyy,cens),dist="normal",pmu=1,psh=0,delta=0.5/yy)
gnlr(cbind(lyy,cens),dist="logistic",pmu=1,psh=0,delta=0.5/yy)
gnlr(cbind(lyy,cens),dist="Laplace",pmu=1,psh=0,delta=0.5/yy)
gnlr(cbind(lyy,cens),dist="Cauchy",pmu=1,psh=0,delta=0.5/yy)

fmr(cbind(yy,cens),dist="gamma",censor="left",mu=mu,pmu=1,psh=-1,pmix=0,
	delta=0.5)
fmr(cbind(yy,cens),dist="Weibull",censor="left",mu=mu,pmu=1,psh=-1,pmix=0,
	delta=0.5)
fmr(cbind(yy,cens),dist="inverse Gauss",censor="left",mu=mu,pmu=1,psh=0,
	pmix=0,delta=0.5)
fmr(cbind(yy,cens),dist="Pareto",censor="left",mu=mu,pmu=1,psh=0,pmix=0,
	delta=0.5)
fmr(cbind(lyy,cens),dist="normal",censor="left",pmu=1,psh=0,pmix=0,
	delta=0.5/yy)
fmr(cbind(lyy,cens),dist="logistic",censor="left",pmu=1,psh=0,pmix=0,
	delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Laplace",censor="left",pmu=1,psh=0,pmix=0,
	delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Cauchy",censor="left",pmu=1,psh=0,pmix=0,
	delta=0.5/yy)

mix <- function(p) p[1]+py*p[2]
fmr(cbind(yy,cens),dist="gamma",censor="left",mu=mu,pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5)
fmr(cbind(yy,cens),dist="Weibull",censor="left",mu=mu,pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5)
fmr(cbind(yy,cens),dist="inverse Gauss",censor="left",mu=mu,pmu=1,psh=0,
	pmix=c(0,0), mix=mix,delta=0.5)
fmr(cbind(yy,cens),dist="Pareto",censor="left",mu=mu,pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5)
fmr(cbind(lyy,cens),dist="normal",censor="left",pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="logistic",censor="left",pmu=1,psh=0,
	pmix=c(0,0), mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Laplace",censor="left",pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Cauchy",censor="left",pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5/yy)

mu <- function(p) exp(p[1]+py*p[2])
mu2 <- function(p) p[1]+py*p[2]
fmr(cbind(yy,cens),dist="gamma",censor="left",mu=mu,pmu=c(1,0),psh=0,
	pmix=c(0,0),mix=mix,delta=0.5)
fmr(cbind(yy,cens),dist="Weibull",censor="left",mu=mu,pmu=c(1,0),psh=0,
	pmix=c(0,0),mix=mix,delta=0.5)
exp(2.9521)
exp(2.9521+0.6755)
exp(-0.3486)/(1+exp(-0.3486))
exp(-0.3486+2.1845)/(1+exp(-0.3486+2.1845))
exp(-0.2144)
fmr(cbind(yy,cens),dist="inverse Gauss",censor="left",mu=mu,pmu=c(1,0),psh=0,
	pmix=c(0,0), mix=mix,delta=0.5)
fmr(cbind(yy,cens),dist="Pareto",censor="left",mu=mu,pmu=c(1,0),psh=0,
	pmix=c(0,0),mix=mix,delta=0.5)
fmr(cbind(lyy,cens),dist="normal",censor="left",mu=mu2,pmu=c(1,0),psh=0,
	pmix=c(0,0),mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="logistic",censor="left",mu=mu2,pmu=c(1,0),psh=0,
	pmix=c(0,0), mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Laplace",censor="left",mu=mu2,pmu=c(2.7,0.6),psh=0.2,
	pmix=c(-0.4,2.1),mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Cauchy",censor="left",mu=mu2,pmu=c(1,0),psh=0,
	pmix=c(0,0),mix=mix,delta=0.5/yy)

if(interactive()){
py <- NULL
j <- 0
for(i in 2:36){
      j <- j+(365+((i%%4)==1))
      py <- c(py,data[j+1])}
yy <- NULL
j <- 0
for(i in 1:36){
      yy <- rbind(yy,data[(1+j):(31+j)])
      j <- j+(365+((i%%4)==1))}
py <- cbind(c(NA,py),yy)
}
